Package org.opensaml.xmlsec.signature

# Interface Signature

All Superinterfaces:
  `XMLObject`

All Known Implementing Classes:
  `SignatureImpl`

public interface Signature extends XMLObject
XMLObject representing an enveloped or detached XML Digital Signature, version 20020212, Signature element.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_ELEMENT_LOCAL_NAME`
Element local name.
`static final QName`
`DEFAULT_ELEMENT_NAME`
Default element name.
`static final String`
`TYPE_LOCAL_NAME`
Local name of the XSI type.
`static final QName`
`TYPE_NAME`
QName of the XSI type.

## Method Summary

Modifier and Type
Method
Description
`String`
`getCanonicalizationAlgorithm()`
Gets the canonicalization algorithm used to create the signature content.
`List<ContentReference>`
`getContentReferences()`
Gets the list of signature content references.
`Integer`
`getHMACOutputLength()`
Gets the HMAC output length value, optionally used when signing with an HMAC signature algorithm.
`KeyInfo`
`getKeyInfo()`
Gets the key info added to this signature.
`String`
`getSignatureAlgorithm()`
Gets the algorithm used to compute the signature.
`Credential`
`getSigningCredential()`
Gets the signature signing credential.
`void`
`setCanonicalizationAlgorithm(String newAlgorithm)`
Sets the canonicalization algorithm used to create the signature content.
`void`
`setHMACOutputLength(Integer length)`
Sets the HMAC output length value, optionally used when signing with an HMAC signature algorithm.
`void`
`setKeyInfo(KeyInfo newKeyInfo)`
Sets the key info added to this signature.
`void`
`setSignatureAlgorithm(String newAlgorithm)`
Sets the algorithm used to compute the signature.
`void`
`setSigningCredential(Credential newCredential)`
Sets the signature signing credential.

### Methods inherited from interface org.opensaml.core.xml.XMLObject

`detach, ensureDOM, getDOM, getElementQName, getIDIndex, getNamespaceManager, getNamespaces, getNoNamespaceSchemaLocation, getObjectMetadata, getOrderedChildren, getParent, getSchemaLocation, getSchemaType, hasChildren, hasParent, isNil, isNilXSBoolean, releaseChildrenDOM, releaseDOM, releaseParentDOM, resolveID, resolveIDFromRoot, setDOM, setNil, setNil, setNoNamespaceSchemaLocation, setParent, setSchemaLocation`

## Field Details

### DEFAULT_ELEMENT_LOCAL_NAME

@Nonnull @NotEmpty static final String DEFAULT_ELEMENT_LOCAL_NAME
Element local name.

See Also:
  - Constant Field Values

### DEFAULT_ELEMENT_NAME

@Nonnull static final QName DEFAULT_ELEMENT_NAME
Default element name.

### TYPE_LOCAL_NAME

@Nonnull @NotEmpty static final String TYPE_LOCAL_NAME
Local name of the XSI type.

See Also:
  - Constant Field Values

### TYPE_NAME

@Nonnull static final QName TYPE_NAME
QName of the XSI type.

## Method Details

### getCanonicalizationAlgorithm

@Nullable String getCanonicalizationAlgorithm()
Gets the canonicalization algorithm used to create the signature content.

Returns:
  the canonicalization algorithm used to create the signature content

### setCanonicalizationAlgorithm

void setCanonicalizationAlgorithm(@Nullable String newAlgorithm)
Sets the canonicalization algorithm used to create the signature content.

Parameters:
  `newAlgorithm` - the canonicalization algorithm used to create the signature content

### getSignatureAlgorithm

@Nullable String getSignatureAlgorithm()
Gets the algorithm used to compute the signature.

Returns:
  the algorithm used to compute the signature

### setSignatureAlgorithm

void setSignatureAlgorithm(@Nullable String newAlgorithm)
Sets the algorithm used to compute the signature.

Parameters:
  `newAlgorithm` - the algorithm used to compute the signature

### getHMACOutputLength

@Nullable Integer getHMACOutputLength()
Gets the HMAC output length value, optionally used when signing with an HMAC signature algorithm.

Returns:
  the HMACOutputLength value

### setHMACOutputLength

void setHMACOutputLength(@Nullable Integer length)
Sets the HMAC output length value, optionally used when signing with an HMAC signature algorithm.

Parameters:
  `length` - the new HMACOutputLength value

### getSigningCredential

@Nullable Credential getSigningCredential()
Gets the signature signing credential.

Returns:
  the signature signing credential

### setSigningCredential

void setSigningCredential(@Nullable Credential newCredential)
Sets the signature signing credential.

Parameters:
  `newCredential` - the signature signing credential

### getKeyInfo

@Nullable KeyInfo getKeyInfo()
Gets the key info added to this signature.

Returns:
  the key info added to this signature

### setKeyInfo

void setKeyInfo(@Nullable KeyInfo newKeyInfo)
Sets the key info added to this signature.

Parameters:
  `newKeyInfo` - the key info added to this signature

### getContentReferences

@Nonnull @Live List<ContentReference> getContentReferences()
Gets the list of signature content references.

Returns:
  the list of signature content references